#include "ImageWin.h"
#include "opteonglue.h"
#include <stdio.h>
#include <iostream>
#include "JDImage.h"
#include "jd_time.h"

using namespace std;

//////////////////////////////////////////////
class VideoWin : public ImageWin {
public:
	VidInfo *vid;
	JDImage  im;
	unsigned long xprevtime;
	int fCamNum;

public: 
	VideoWin(int camNum=0) {
		im.resize(640,480);

		vid=NULL;
		vid=vidInit(camNum);		
		if (vid==NULL) exit(1);

		fCamNum=camNum;
		renderBGRA=true;  // Because we capture in this order natively
	}

	void display() {

		vidIn_BGRA(vid, im);        // capture an image

		ImageWin::attachImage(im);  // display the captured image
		ImageWin::display();
                                    // keep track of ms between frames
		unsigned long time=Get_Milliseconds();
		cout << fCamNum << " " << time << " " << time-xprevtime << endl;
		xprevtime=time;
		glutPostRedisplay();
	}

	virtual ~VideoWin() {
		puts ("Closing VideoWin");
		vidQuit(vid); 
	}
};

//////////////////////////////////////////////
void main() 
{
	int numCams=vidGetNumCameras();

	for (int i=0;i<numCams;i++) {
		VideoWin *win=new VideoWin(i);
	}

	glutMainLoop();
}