#include "Kernel.h"
#include <math.h>
#include "jed.h"

using namespace std;

Kernel K_gaussian(double sigma)
{
  // figure width
  int w=sigma*2.5+1;
  
  // create kernel
  Kernel k;
  
  // fill in values
  for (int i= -w;i<=w;i++) {
    double val=((double)(i)/(2*sigma));
    val = exp(-(val*val));
    k.push_back(val);
  }
  
  // normalize
  k=K_normalize(k);
  
  // return
  return k;
}

Kernel K_normalize(Kernel k)
{
  double tot=0;
  
  // Add up all values
  for (int i=0;i <k.size(); i++) {
    tot += k[i];
  }
    
  // Divide all values by total
  for (int i=0;i <k.size(); i++) {
    k[i] = k[i]/tot;
  }

  return k;
}

ostream& operator<< (ostream&s, const Kernel &k)
{
  for (int i=0;i<k.size();i++)
    {
      s << k[i] << " " ;
    }

  return s;
}
