
#include "vidInterfaceVisionSDK.h"

//#include "ImageWin.h"
#include <iostream.h>
#include "CLO.h"
#include "FImage.h"

int main(int argc, char *argv[])
{
	// Command line arguments
	CLOchar255 inName(REQUIRED, "i","filename","Input avi file name");
	CLOchar255 outName(REQUIRED,"o","filename","Output avi file name");
	CLOfloat   blurRadius(5.0,"b","pixels","Width of gaussian blur filter");
	CLOflag    silent("s","Turn on silent mode on stdout");
	CLO::parseArgs(argc,argv);

	// Open the movie file in question
	MVid movieIn;
	movieOpen(inName,movieIn);

	// Create an output movie file 
	MVid movieOut;
	movieCreate(outName,movieOut);

	// Set the blur radius
    Kernel k=K_gaussian(blurRadius);

	// Get some storage for a frame
	JDImage thisFrame;
	FImage fFrame;

	// Diagnostic
	if (!silent) puts ("Creating blurry b/w movie!");

	// Loop over all movie frames
	for (int i=0;i<movieNumFrames(movieIn);i++) {
	
		// Read from the input movie
		movieGetFrame(movieIn, i, thisFrame);

		// Copy the (int) data to a (float) b/w image class
		fFrame=thisFrame;

		// Blur the frame 
        fFrame.blur(k);

		// Copy the (float) image back to (int) image
	    fFrame.getJDImage(thisFrame);

		// Write to the output movie
		moviePutFrame(movieOut, i, thisFrame);

		// Diagnostic
		if (!silent) printf("Frame: %d  \n", i);
	}

	// Close the movies 
	movieClose(movieIn);
	movieClose(movieOut);

    return 0;
}
