#include <GL/glut.h>
#include "glutTools.h"
#include <string.h>

void glutClearMenu()
{
  int numMenuItems=glutGet(GLUT_MENU_NUM_ITEMS);
  for (int i=numMenuItems;i>0;i--)
    {
      glutRemoveMenuItem(i);
    }

}
 
// maintain local font and position of text. Dont mess with gl states
void *gCurGlutFont=GLUT_BITMAP_HELVETICA_10;
static float gTextPosX, gTextPosY, gTextPosZ;

void glutSetFont(void *font)
{
  gCurGlutFont = font;
}

void glutSetStringPos(float x, float y, float z)
{
  gTextPosX=x;
  gTextPosY=y;
  gTextPosZ=z;
}

int glutBitmapStringWidth(const char *str)
{
  int w=0;
  const char *c=str;

  while (*c != '\0')
    {
      w += glutBitmapWidth(gCurGlutFont,*c);
      c++;
    }
  
 return w;
}

void glutBitmapString(const char *str)
{
  // save old raster pos
  float rasterpos[4];
  glGetFloatv(GL_CURRENT_RASTER_POSITION,rasterpos);
    
  // set string raster pos
  glRasterPos3f(gTextPosX,gTextPosY,gTextPosZ);

  // print string
  int len = strlen(str);
  for (int i=0;i<len;i++)
    {
      glutBitmapCharacter(gCurGlutFont, str[i]);
      gTextPosX += glutBitmapWidth(gCurGlutFont, str[i]);
    }

  // restore raster pos
  glRasterPos4fv(rasterpos);
}
