#ifndef MSG_H
#define MSG_H

#include "MsgPipe.h"

class Msg 
{

public: 
  MsgPipe *pipe;
  short   indentLevel;  //private
  short   indentState;  //private
  
public:
  Msg();
  Msg(MsgPipe *pipe);
  
  virtual ~Msg();
  
  Msg &print(char *str);
  Msg &printRaw(char *str);
  Msg &print(int str);
  Msg &printRaw(int str);
  Msg &print(float str);
  Msg &printRaw(float str);
  Msg &err(char *str);
  void halt(char *str);
  
  Msg &indent(short lvls=1);
  Msg &unindent();
  
  MsgPipe *pushPipe(MsgPipe *pipe);
  MsgPipe *popPipe();
 
private:
  void indentFilter(char *str);
  

};

extern Msg msg;

#endif 

