//
// noise.h
//
// $Id: noise.h,v 1.1 2003/05/22 01:13:24 jedavis Exp $
//

#ifndef SGL_NOISE_H
#define SGL_NOISE_H

#include <sgl/defs.h>
#include <sgl/tuples.h>
#include <sgl/wnoise.h>

class Vector3;

extern double Noise(double x);

extern double Noise2(double x, double y);
extern double DNoise2(double x, double y, double *dx, double *dy);

extern double Noise3(double x, double y, double z);
extern double Noise3(const Tuple3d &p);

extern Vector3 DNoise3(double x, double y, double z);
extern Vector3 DNoise3(const Tuple3d &p);

extern double FBm(double x, double y, double z, double omega, 
		  double lambda, double octaves);
extern double FBm(const Tuple3d &p, double omega, double lambda, 
		  double octaves);

extern double Chaos(double x, double y, double z, double octaves);
extern double Chaos(const Tuple3d &p, double octaves);

extern Vector3 VfBm(double x, double y, double z, double omega, 
		    double lambda, double octaves);
extern Vector3 VfBm(const Tuple3d &p, double omega, double lambda,
		    double octaves);


#endif /* SGL_NOISE_H */
