
#ifndef IMAGEINFO_H
#define IMAGEINFO_H

#define FOUR_BYTES long

#include <stdio.h>

// The convention is that ImageInfo does not own the pixels, so
// does not delete this memory. Its just a pointer to the real data.

class ImageInfo 
{

public: 
  
  FOUR_BYTES *pixels;
  short xsize;
  short ysize;
   
public:
  ImageInfo();
  ImageInfo(FOUR_BYTES *pixels, short xsize, short ysize);

#ifdef WIN32
  inline unsigned char &r(int x, int y)
    {      return *(((unsigned char *)(pixels+xsize*y+x))+0);    }
  inline unsigned char &g(int x, int y)
    {      return *(((unsigned char *)(pixels+xsize*y+x))+1);    }
  inline unsigned char &b(int x, int y)
    {      return *(((unsigned char *)(pixels+xsize*y+x))+2);    }
  inline unsigned char &a(int x, int y)
    {      return *(((unsigned char *)(pixels+xsize*y+x))+3);    }
  inline FOUR_BYTES &pix(int x, int y)
    {      return *(pixels+xsize*y+x); }
#else
  inline unsigned char &r(int x, int y)
    {    return *(((unsigned char *)(pixels+xsize*y+x))+3);    }
  inline unsigned char &g(int x, int y)
    {      return *(((unsigned char *)(pixels+xsize*y+x))+2);    }
  inline unsigned char &b(int x, int y)
    {      return *(((unsigned char *)(pixels+xsize*y+x))+1);    }
  inline unsigned char &a(int x, int y)
    {      return *(((unsigned char *)(pixels+xsize*y+x))+0);    }
  inline FOUR_BYTES &pix(int x, int y)
    {      return *(pixels+xsize*y+x); }
#endif

};



#endif 

