#include "JDImage.h"
#include <stdlib.h>
#include <string.h>
 
#ifdef WIN32
#pragma warning (disable : 4244 4800 4018)
#endif 

JDImage::JDImage()
{
  pixels=NULL;
  resize(0,0);
}

JDImage::JDImage(short x, short y)
{
pixels=NULL;
resize(x,y); 
}
   
void JDImage::resize(short x, short y)
{
  if (pixels!=NULL)
    delete [] pixels;
  xsize = x;
  ysize = y;
  pixels = new long[x*y];
}
 
JDImage::~JDImage()
{
delete [] pixels;
}

JDImage &JDImage::operator=(ImageInfo im)
{
  resize(im.xsize,im.ysize); 
  memcpy(pixels,im.pixels,xsize*ysize*4);

  return *this;
}

JDImage &JDImage::operator=(JDImage &im)
{
  resize(im.xsize,im.ysize); 
  memcpy(pixels,im.pixels,xsize*ysize*4);

  return *this;
}


void JDImage::setAlpha255()
{
  for (int i=0;i<xsize;i=i+1)
	  for (int j=0;j<ysize;j++) {
		a(i,j)=255;
	  }
}

void JDImage::resamplePixels(ImageInfo &im)
{
  double imx=im.xsize;
  double imy=im.ysize;
  double sx=imx/(double)xsize;
  double sy=imy/(double)ysize;
  
  for (int i=0;i<xsize; i++)
    for (int j=0;j<ysize; j++)
      {
	pix(i,j)=im.pix(i*sx,j*sy);
      }
}

void JDImage::resizeKeepingPixels(short x, short y)
{
  JDImage im;
  im= *this;
  resize(x,y);
  resamplePixels(im);
}
