#ifndef JED_H
#define JED_H

#ifndef MIN
#define MIN(x,y) ((x)<(y)?(x):(y))
#endif

#ifndef MAX
#define MAX(x,y) ((x)>(y)?(x):(y))
#endif

#define CLAMP(x,l,h) MAX(MIN((x),(h)),(l))

#define CSTR(var) const_cast<char *>(var.c_str())

#ifdef WIN32
// Set the amount of name shown for COUT 
#define DLEN 10
// Set up to get the tail of the filename
#define REMOVEHEAD FNT_removeHead
#else
// In unix we might not need this ??
#define DLEN 6
#define REMOVEHEAD
#endif 

static const char * FNT_removeHead(const char *str)
{
	// Search backwards from the end for a slash and return just the tail
	const char *cur=str+strlen(str);
	while (cur!=str) {
		if (cur[0]=='/' || cur[0]=='\\') {
			return cur+1;
		}
		cur--;
	}

	return str;
}


#define DTAG {char df[1024]; strcpy(df,REMOVEHEAD(__FILE__)); strcat(df,"      "); sprintf(df+DLEN,"%3d: ",__LINE__); cout << df ;}
#define DTAGO {char df[1024]; strcpy(df,REMOVEHEAD(__FILE__)); strcat(df,"      "); sprintf(df+DLEN,"%3d: ",__LINE__); printf(df) ;}

#define COUT DTAG; std::cout
#define PUTS DTAGO; puts
#define PRINTF DTAGO; printf

// Fix MS Vis studio weird stuff
#ifdef WIN32

// Visual Studio wont take for (int i,...); for (int i,...);
#define for if (0) ; else for

// usleep doesn't exist on Windows
#define usleep(x) Sleep((x)/1000)

// rint doesn't exist on Windows
#define rint(x) floor((x)+0.5)

#endif

#endif 

