#ifndef MY_SOCK_WRAPPER_H
#define MY_SOCK_WRAPPER_H

#ifndef WIN32
#ifndef sgi
#define sgi
#endif
#endif


#ifdef sgi
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <netdb.h>

#include <unistd.h>
#include <termios.h>
#include <strings.h>

#else
#include <winsock.h>
#endif

#ifndef sgi
#define close(s) closesocket(s)
#define ioctl(s,cmd,argp) ioctlsocket(s,cmd,argp)
#define sleep(second) Sleep((second)*1000)
#define usleep(microsecond) Sleep((microsecond)/1000)
#endif

#ifdef sgi
#define global_read(a,b,c) ::read(a,b,c)
#define global_write(a,b,c) ::write(a,b,c)
#else
#define global_read(a,b,c) recv(a,(char *)b,c,0)
#define global_write(a,b,c) send(a,(char *)b,c,0)
#endif

int socketStartup();
int socketCleanup();

#endif
