#include "JDImage.h"
#include "JDMovie.h"
#include <stdio.h>
#include <stdlib.h>
#include "auxWindow.h"
#include <GL/gl.h>
#include "vid.h"

main(int argc, char **argv)
{
  
  if(argc<2)
    {
      puts ("usage: vid2movie <filename>");
      exit(2);
    }

  MVid movie;

  // open the video stream
  VidInfo *info=vidInit();

  // set half size frames
  vidSetZoom(info,1,2);

  long xsize ,ysize ;

  // how big is each frame?
  vidGetXYSize(info, &xsize ,&ysize);

  // create a movie file 
  movieCreate(argv[1],movie, xsize, ysize);

  // create a window
  auxMakeWindow(xsize,ysize,1);

  // allocate frame space
  JDImage frame(xsize, ysize);

  for (int i=0;i<20;i++ )
    {

      // get a frame from the camera
      frame.pixels = (long *) vidInLatest(info);
    
      // draw the frame to screen
      glDrawPixels(xsize,ysize,  GL_ABGR_EXT, GL_UNSIGNED_BYTE, 
		   (char*)frame.pixels);

      // save the frame to the file
      moviePutFrame(movie, i,frame);
    }

  // close the movie file (important)
  movieClose(movie);

}
