// Just uses the vision SDK to compress an AVI. Using the
// dialog box that they pop up.

#include "vidInterfaceVisionSDK.h"

#include <iostream.h>



int main(int argc, const char *argv[])
{
	// Check for filename argument
    if ( argc < 3 ) {
		fprintf(stderr,"Usage: %s: input.avi output.avi\n",argv[0]);
		return -1;
	}

	// Open the movie file in question
	MVid movieIn;
	movieOpen(argv[1],movieIn);

	// Create an output movie file 
	MVid movieOut;
	movieCreateWithCompressDialog(argv[2],movieOut);

	// Get some storage for a frame
	JDImage thisFrame;

	// Loop over all movie frames
	for (int i=0;i<movieNumFrames(movieIn);i++) {
	
		// Read from the input movie
		movieGetFrame(movieIn, i, thisFrame);

		// Write to the output movie
		moviePutFrame(movieOut, i, thisFrame);

		// Diagnostic
		printf("Adding frame: %d  \n", i);
	}

	// Close the movies
	movieClose(movieIn);
	movieClose(movieOut);
 
    return 0;
}


