
#include "vidInterfaceVisionSDK.h"

#include "ImageWin.h"
#include <iostream.h>


class MovieWin : ImageWin {
public:
	int curFrameNum;
	MVid movie;
	JDImage curFrame;

	MovieWin() {curFrameNum=0;  setIdleInterval(200);}

	// This idle() routine gets run every 200ms
	// displaying the image is handled by the routine in ImageWin
	void idle() {

		// Increment the current frame number
		curFrameNum = (curFrameNum+1)%movieNumFrames(movie);

		// Get the correct frame from the movie file
		movieGetFrame(movie, curFrameNum, curFrame);

		// Make this the current image for ImageWin->display();
		attachImage(curFrame);

		// Print a diagnostic
		printf ("Showing frame: %d\n",curFrameNum);
	}
};


int main(int argc, const char *argv[])
{
	// Check for filename argument
    if ( argc < 2 ) {
		fprintf(stderr,"Usage %s: input.avi\n",argv[0]);
		return -1;
	}

	// Create a window that knows how to play movies
	MovieWin mwin;

	// Open the movie file in question
	movieOpen(argv[1],mwin.movie);

	// Enter the glut main loop, which falls through to idle() above
	glutMainLoop();

    return 0;
}


// Conceptually this is the same as
//
// MVid movie;
// movieOpen(filename, movie);
// for (i=0;i<movieNumFrames(movie);i++) {
//   JDImage im;
//   movieGetFrame(movie, i, im);
//   showImageInWindow(im);
// }
//
//
// Its more complicated because of the glut event loop