#ifndef _BBOX_
#define _BBOX_

#include "scalar.h"
#include "vector.h"

template <int N> class BBox {
    public:
        BBox(void) { Reset(); }
            
        void Reset(void) 
        {
            for (int i = 0; i < N; i++) {
                min[i] = SCALAR_MAX;
                max[i] = SCALAR_MIN;
            }
        }
        BBox(Vector<N> _min, Vector<N> _max)
        {
            min = _min;
            max = _max;
        }
        void Merge(const Vector<N> &p) {
            for (int i = 0; i < N; i++) {
                if (p[i] < min[i]) min[i] = p[i];
                if (p[i] > max[i]) max[i] = p[i];
            }
        }
        Vector<N> GetMin(void) const { return min; }
        Vector<N> GetMax(void) const { return max; }
        Vector<N> GetSize() { return max - min; }
        Vector<N> GetCenter(void) const { return (max + min)/2; }

    private:
        Vector<N> min, max;
};

typedef BBox<2> BBox2;
typedef BBox<3> BBox3;

#endif // _BBOX_
