#ifndef TIME_H
#define TIME_H

#ifdef WIN32
#include <windows.h>
#else
#include <sys/times.h>
#include <time.h>
#include <unistd.h>
#endif

class Time {
    public:
        void Reset(void) { time = Get(); }
        double Elapsed(void) { return Get() - time; }
        double Get(void)
        {
#ifdef WIN32
            return 0.001*GetTickCount();
#else
            struct tms t;
            return 0.001*(times(&t)*1000)/CLK_TCK;
#endif
        }
    private:
        double time;
};

#endif // TIME_H
