#ifndef _WINDOW_H_
#define _WINDOW_H_

#include <cstdlib>

#include "error.h"
#include "glutwm.h"

class Window {
    public:
        Window(void) { id = 0; }
        virtual ~Window(void) { ; }
        virtual void Init(int _id) { id = _id; }
        virtual void Destroy(void) { id = 0; }
        virtual void Display(void) { ; }
        virtual void Idle(void) { GlutWMStopIdle(id); }
        virtual void Reshape(int _w, int _h, int _x0 = 0, int _y0 = 0) 
        { x0 = _x0; y0 = _y0; w = _w; h = _h; } 
        virtual void Motion(int x, int y) { ; }
        virtual void Button(int button, int state, int x, int y) { ; }
        virtual void Keyboard(unsigned char c, int x, int y) 
        { if (c == 'q' || c == 'Q') exit(0); }
        virtual void Adjust(int *x, int *y) 
        { *x = *x - x0; *y = h - (*y - y0) - 1; }
        virtual int GetWidth(void) { return w; }
        virtual int GetHeight(void) { return h; }
        virtual int GetId(void) { return id; }
        virtual int GetX0(void) { return x0; }
        virtual int GetY0(void) { return y0; }
    private:
        int id, x0, y0, w, h;
};

#endif // _WINDOW_H_
